
/*
*  AntiCrack.h
*   Author  : sky(shu)
*   License : NYSL
*/

#ifndef ANTICRACK_H_INCLUDED_
#define ANTICRACK_H_INCLUDED_


#include "crc32.h"

#ifdef __cplusplus
  #define INLINE inline
#else
  #define INLINE __inline
#endif

/*
 萔̏C
#define SET_VAR(v) (v)
#define GET_VAR(v) (v)
*/
#define SET_VARA(v) ((v*3)^0x0F5FAFEF)
#define GET_VARA(v) ((v^0x0F5FAFEF)/3)
#define SET_VARB(v) ((v*5)-0x0F2E15C2)
#define GET_VARB(v) ((v+0x0F2E15C2)/5)

/*
*  ֐|C^̃AhXU
*/
#define SET_FN_PTR(func,num)               \
	static INLINE void *get_##func(void)   \
	{                                      \
		int i, j = num / 4;                \
		int ptr = (int)func + num;         \
		for( i = 0; i < 2; i++ ) ptr -= j; \
		return (void*)(ptr - (j*2));       \
	}
#define GET_FN_PTR(func) get_##func()

/*
*  ֐̋@B
*/
#define FUNC_END(func) void func_end_##func(void){}
#define FUNC_LEN(func) (int)func_end_##func - (int)func
#define FUNC_PTR(func) (unsigned char*)func

#define GET_FUNC_CRC(func) (crc32(FUNC_PTR(func),FUNC_LEN(func)))



#endif
