
/*
*  SecureMemory.h
*   Author  : sky(shu)
*   License : NYSL
*/

#ifndef SECUREMEMORY_H_INCLUDED_
#define SECUREMEMORY_H_INCLUDED_

#include "crc32.h"

/*
*  ̉₃`FbN
*/

typedef struct {
	unsigned char *ptr;
	unsigned int len;
	unsigned int crc;
}MemCheck;

static void UpdateMemory( MemCheck *m )
{
	m->crc = crc32(m->ptr,m->len);
}

static int IsAlteredMemory( MemCheck *m )
{
	return m->crc ^ crc32( m->ptr, m->len );
}

//#define UpdateMemory(m) m.crc=crc32(m.ptr,m.len)
//#define IsAltered(m) if( m.crc^crc32(m.ptr,m.len) )


/*
*  ̑ύX
*/

/*
typedef enum {
	MEMP_READ,
	MEMP_WRITE,
	MEMP_EXEC,
	MEMP_NOACCESS
}MEM_PROTECT;

#ifdef WIN32
#include <windows.h>

#else
#include <sys/mman.h>	// int mprotect(const void *addr, size_t len, int prot); PROT_ NONE, READ, WRITE, EXEC

#endif
*/


#endif
